VERSION 5.00
Begin VB.UserControl Clock 
   ClientHeight    =   315
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1635
   ScaleHeight     =   315
   ScaleWidth      =   1635
End
Attribute VB_Name = "Clock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' A simple demo of how to use a ccrpTimer within a UserControl.
' The comlexity of this control was minimized to the max, in order
' to focus on the simple mechanics of Implementing timer notification.

Option Explicit

Implements ICcrpTimerNotify

Private m_Timer As ccrpTimer
Private m_Colon As Boolean
Private m_Offset As Double

Private Sub ICcrpTimerNotify_Timer(ByVal Milliseconds As Long)
   m_Colon = Not m_Colon
   Call Refresh
End Sub

Private Sub UserControl_Initialize()
   Set m_Timer = New ccrpTimer
   With m_Timer
      .EventType = TimerPeriodic
      .Interval = 500
      .Stats.Frequency = 50
      Set .Notify = Me
   End With
   
   With UserControl
      .ScaleMode = vbPixels
      .AutoRedraw = True
   End With
   
   m_Colon = True
End Sub

Private Sub UserControl_Paint()
   Me.Refresh
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   m_Timer.Enabled = Ambient.UserMode
End Sub

Private Sub UserControl_Resize()
   Me.Refresh
End Sub

Private Sub UserControl_Terminate()
   m_Timer.Enabled = False
   Set m_Timer = Nothing
   Debug.Print "UserControl_Terminate!"
End Sub

Public Property Let Offset(ByVal NewVal As Double)
   m_Offset = NewVal
   Me.Refresh
End Property

Public Property Get Offset() As Double
   Offset = m_Offset
End Property

Public Static Sub Refresh()
   Dim disp As String
   Dim i As Long
   
   disp = Format$(Now + m_Offset, "long time")
   With UserControl
      .Cls
      .CurrentX = (.ScaleWidth - .TextWidth(disp)) \ 2
      .CurrentY = (.ScaleHeight \ 2) - (.TextHeight(disp) \ 2)
      If Not m_Colon Then
         For i = 1 To Len(disp)
            If InStr(i, disp, ":") = i Then
               Mid$(disp, i, 1) = " "
            End If
         Next i
      End If
      UserControl.Print disp
      UserControl.Line (0, 0)-(.ScaleWidth - 1, .ScaleHeight - 1), , B
   End With
End Sub

