VERSION 5.00
Begin VB.Form frmTabForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Tabs"
   ClientHeight    =   2535
   ClientLeft      =   3090
   ClientTop       =   1995
   ClientWidth     =   3435
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2535
   ScaleWidth      =   3435
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdClearAll 
      Caption         =   "Clear &All"
      Height          =   315
      Left            =   1980
      TabIndex        =   7
      Top             =   2100
      Width           =   1335
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear"
      Enabled         =   0   'False
      Height          =   315
      Left            =   1980
      TabIndex        =   6
      Top             =   1740
      Width           =   1335
   End
   Begin VB.CommandButton cmdSet 
      Caption         =   "&Set"
      Enabled         =   0   'False
      Height          =   315
      Left            =   1980
      TabIndex        =   5
      Top             =   1380
      Width           =   1335
   End
   Begin VB.CommandButton cmdCxl 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   315
      Left            =   1980
      TabIndex        =   4
      Top             =   840
      Width           =   1335
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   315
      Left            =   1980
      TabIndex        =   3
      Top             =   480
      Width           =   1335
   End
   Begin VB.ListBox lstTabs 
      Height          =   1425
      Left            =   240
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   840
      Width           =   1455
   End
   Begin VB.TextBox txtTabStop 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.Label lblLabel1 
      Caption         =   "Tab Stop Position:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1635
   End
End
Attribute VB_Name = "frmTabForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1   ' set the default lower array limit

Dim mblnLoading As Boolean 'form loading flag

'*************************************************
' Purpose:  Add a tab to the list
'*************************************************
Private Sub btnAdd_Click()
    Dim intI As Integer 'counter
    Dim blnMatch As Boolean 'match flag

    blnMatch = False ' set match flag to false
    ' check to see if new tab is already in list
    For intI = 0 To lstTabs.ListCount - 1
        If txtTabStop.Text = lstTabs.List(intI) Then
            ' text is in list, match flag = true
            blnMatch = True
        End If
    Next intI
    
    If Not blnMatch Then ' if no match
        ' add it to the list
        lstTabs.AddItem txtTabStop.Text
    End If
End Sub


'*************************************************
' Purpose:  Filter key presses (limit to numbers)
'*************************************************
Private Sub cboTab_KeyPress(KeyAscii As Integer)
    If Not ((KeyAscii >= Asc("0") And KeyAscii <= Asc("9")) Or KeyAscii = Asc(".")) Then
        KeyAscii = 0 ' discard key press
        Beep
    End If
End Sub


'*************************************************
' Purpose:  Set tabs on the active RTF control
'*************************************************
Sub SetTabs()
    With frmText
        'update the list on the active form
        Dim intI As Integer
        
        .ScaleMode = 1 'twips
        .rtfTextEditor.SelTabCount = lstTabs.ListCount
        ReDim intOldTabs(0 To .rtfTextEditor.SelTabCount)
        For intI = 0 To lstTabs.ListCount - 1
            ' add new items to list
            .rtfTextEditor.SelTabs(intI) = lstTabs.List(intI) * 1440#
            intOldTabs(intI) = .rtfTextEditor.SelTabs(intI)
        Next intI
    End With
End Sub

'*************************************************
' Purpose:  Clears the current item from the tab list.
'*************************************************
Private Sub cmdClear_Click()
    ' remove it
    lstTabs.RemoveItem lstTabs.ListIndex
    ' disable the clear button
    cmdClear.Enabled = False
    ' enable the set button
    cmdSet.Enabled = True
    ' set focus to the set button
    cmdSet.SetFocus
End Sub

'*************************************************
' Purpose:  To clear all the tabs from the list box.
'*************************************************
Private Sub cmdClearAll_Click()
    lstTabs.Clear ' clear them
    txtTabStop.Text = "" 'clear the tab text
    txtTabStop.SetFocus 'set focus to the new tab box
End Sub

'*************************************************
' Purpose:  Unload the form
'*************************************************
Private Sub cmdCxl_Click()
    Unload Me
End Sub

'***************************************************
' Purpose:  Sets the new tab values on the document
'           that called this dialog box.
'***************************************************
Private Sub cmdOK_Click()
    SetTabs ' call the sub that actually sets the
            'tabs on the calling form
    Unload Me ' close the form
End Sub

'*************************************************
' Purpose:  Add the new tab to the list
'*************************************************
Private Sub cmdSet_Click()
    ' add the tab.
    lstTabs.AddItem txtTabStop.Text
    ' enable the clear button
    cmdClear.Enabled = True
    ' disable the set button
    cmdSet.Enabled = False
End Sub

'*************************************************
' Purpose:  Set loading flag
'*************************************************
Private Sub Form_Load()
   Call sCenterForm(Me)
    mblnLoading = True
End Sub

'***************************************************
' Purpose:  To load the tab values from the calling
'           form into this form
'***************************************************
Private Sub Form_Paint()
    If mblnLoading = True Then 'form has loaded
        With frmMains.ActiveForm
            Dim intI As Integer 'counter
            For intI = 0 To .rtfTextEditor.SelTabCount - 1
                ' add RTF items into list
                'MsgBox .rtfTextEditor.SelTabs(intI)
                Dim sglTabValue As Single
                sglTabValue = .rtfTextEditor.SelTabs(intI) / 1440#
                sglTabValue = CInt(sglTabValue * 100) / 100#
                lstTabs.AddItem Str(sglTabValue)
            Next intI
        End With
        mblnLoading = False 'done with flag
    End If
End Sub



'*************************************************
' Purpose:  Update the edit box for the tab.
'*************************************************
Private Sub lstTabs_Click()
    ' set the tab text to the
    ' list text of the selected item
    txtTabStop.Text = Trim(lstTabs.List(lstTabs.ListIndex))
End Sub

'*************************************************
' Purpose:  Set the enabled properties of the buttons
'           depending on the contents of the text box.
'*************************************************
Private Sub txtTabStop_Change()
    If Len(txtTabStop.Text) > 0 Then
        ' tab text exists.
        ' enable 'set' button
        cmdSet.Enabled = True
        Dim intI As Integer 'counter
        For intI = 0 To lstTabs.ListCount - 1
            If Val(txtTabStop.Text) = Val(lstTabs.List(intI)) Then
                ' text also exists in list
                ' enable 'clear', disable 'set'
                cmdClear.Enabled = True
                cmdSet.Enabled = False
                ' set the list index of the box to the
                ' one that matches what the user entered.
                lstTabs.ListIndex = intI
                ' move the selection cursor to the
                ' user end of the input string
                txtTabStop.SelStart = Len(txtTabStop.Text)
                txtTabStop.SelLength = 0
            End If
        Next intI
    Else
        ' No text
        ' disable 'clear' and 'set' buttons
        cmdSet.Enabled = False
        cmdClear.Enabled = False
    End If
End Sub


